%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Gary Poon
% Ryan Wilshusen
%
% Red Eye Reduction Project
% This script finds eyes
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


norm_orig_image = double(orig_image)/255;
% norm_orig_image = norm_orig_image .^ 0.9; % Attenuating eyes (0.3)

figure;
imshow(norm_orig_image);
title('Original Image');

% yiq_image = rgb2ntsc(norm_orig_image); %convert to YIQ -- enhancement = YUV
yuv_image = colorspace('yuv<-rgb',norm_orig_image);

[width length color_height] = size(orig_image); %image dimensions

r_image=orig_image(:, :, 1); %red image
g_image=orig_image(:, :, 2); %green image
b_image=orig_image(:, :, 3); %blue image

y_image=yuv_image(:, :, 1); %luminance image
u_image=yuv_image(:, :, 2); %hue image
v_image=yuv_image(:, :, 3); %saturation image

red_detect_image = u_image;




% RBG Images
% figure
% imshow(r_image)
% title('red image')
% 
% figure
% imshow(b_image)
% title('blue image')
% 
% figure
% imshow(g_image)
% title('green image')

% YUV Images
% figure
% imshow(y_image)
% title('luminance image')
% imwrite(y_image, 'luminance.jpg', 'quality', 100);
% 
% figure
% imshow(u_image)
% title('hue image')
% imwrite(u_image, 'hue.jpg', 'quality', 100);
% 
% figure
% imshow(v_image)
% title('saturation image')
% imwrite(v_image, 'saturation.jpg', 'quality', 100);

% YUV Surfaces
% figure
% surfc(y_image)
% 
% figure
% surfc(u_image)
% 
% figure
% surfc(v_image)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% find max of YUV channels. Max of Y and U channels is 1-min(u)... ok I'm
% not so sure what the hell is going on with the Y channel

min_x_y = min(y_image,[],1); %dim 1 (x)
min_y_y = min(y_image,[],2); %dim 2 (y)

max_x_y = 1-min_x_y;
max_y_y = 1-min_y_y;

min_x_u = min(u_image,[],1); %dim 1 (x)
min_y_u = min(u_image,[],2); %dim 2 (y)

max_x_u = 1-min_x_u;
max_y_u = 1-min_y_u;

max_x_u_orig = max_x_u;
max_y_u_orig = max_y_u;

i = 2;
for i = 3:max(size(max_x_u)-2)
    max_x_u(i) = (max_x_u(i-2) + max_x_u(i-1) + max_x_u(i) + max_x_u(i+1) + max_x_u(i+2))/5;
end

i = 2;
for i = 3:max(size(max_y_u)-2)
    max_y_u(i) = (max_y_u(i-2) + max_y_u(i-1) + max_y_u(i) + max_y_u(i+1) + max_y_u(i+2))/5;
end

max_x_v = max(v_image,[],1); %dim 1 (x)
max_y_v = max(v_image,[],2); %dim 2 (y)

max_x_v_orig = max_x_v;
max_y_v_orig = max_y_v;

% 3 tap smoothing filter
% i = 2;
% for i = 2:max(size(max_x_v)-1)
%     max_x_v(i) = (max_x_v(i-1) + max_x_v(i) + max_x_v(i+1))/3;
% end
% 
% i = 2;
% for i = 2:max(size(max_y_v)-1)
%     max_y_v(i) = (max_y_v(i-1) + max_y_v(i) + max_y_v(i+1))/3;
% end

% 5 tap smoothing filter
i = 2;
for i = 3:max(size(max_x_v)-2)
    max_x_v(i) = (max_x_v(i-2) + max_x_v(i-1) + max_x_v(i) + max_x_v(i+1) + max_x_v(i+2))/5;
end

i = 2;
for i = 3:max(size(max_y_v)-2)
    max_y_v(i) = (max_y_v(i-2) + max_y_v(i-1) + max_y_v(i) + max_y_v(i+1) + max_y_v(i+2))/5;
end

max_x_u = max_x_u + max_x_v; % this is a test of adding Cr and Cb channels
max_y_u = max_y_u + max_y_v;

max_x_u_orig = max_x_u_orig + max_x_v_orig; % this is a test of adding Cr and Cb channels
max_y_u_orig = max_y_u_orig + max_y_v_orig;

figure;
subplot(2,1,1);
plot(max_x_u);
[peak_x_u, neg_x_u] = peakdetect(max_x_u);
title('Max of U + V channel with smoothing filter');
subplot(2,1,2);
plot(max_y_u);
[peak_y_u, neg_y_u] = peakdetect(max_y_u);

figure;
subplot(2,1,1);
plot(max_x_u_orig);
[peak_x_u_orig, neg_x_u_orig] = peakdetect(max_x_u_orig);
title('Max of U + V channel');
subplot(2,1,2);
plot(max_y_u_orig);
[peak_y_u_orig, neg_y_u_orig] = peakdetect(max_y_u_orig);

% figure;
% subplot(2,1,1);
% plot(max_x_v);
% [peak_x_v, neg_x_v] = peakdetect(max_x_v);
% title('Max of V channel');
% subplot(2,1,2);
% plot(max_y_v);
% [peak_y_v, neg_y_v] = peakdetect(max_y_v);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% find very tall peaks that correlate within a predetermined area (the size
% of an eye)

threshold = 0.09;
eye = 0;
xu = 1;
left_neg_xu = 1;
right_neg_xu = max(size(peak_x_u));
expected_eye_width = 55;
expected_eye_height = 45;
for xu = 3:max(size(peak_x_u)-2) % skip first two samples to assure a pos and neg are on each side, length command is not working here
    for left_neg_xu = 1:max(size(neg_x_u)) % this might be peak_x_u
        if neg_x_u(left_neg_xu) < peak_x_u(xu)
            left_neg = left_neg_xu;
        end
    end
    left_side_peak = max_x_u(peak_x_u(xu)) - max_x_u(neg_x_u(left_neg_xu));
    for right_neg_xu = 1:max(size(neg_x_u)) % this might be peak_x_u
        if neg_x_u(right_neg_xu) > peak_x_u(xu)
            right_neg = right_neg_xu;
            break
        end
    end
    normal_peak_height_x = max_x_u(peak_x_u(xu)) - max(max_x_u(neg_x_u(right_neg)), max_x_u(neg_x_u(left_neg)));
    if normal_peak_height_x >= threshold
        eye_x_u(xu) = normal_peak_height_x;
        eye = eye + 1;
        eye_coordinates_x(2 * eye -1) = neg_x_u(left_neg);
        eye_coordinates_x(2 * eye) = neg_x_u(right_neg);
    else
        eye_x_u(xu) = 0;
    end
end

yu = 1;
up_neg_yu = 1;
down_neg_yu = 1;
eye_coordinates_y = zeros(1,eye * 2);

if eye > 0
    eye_count = 1;
else
    eye_count = 0;
end

for yu = 3:max(size(peak_y_u)-2)
    for up_neg_yu = 1:max(size(neg_y_u)) 
        if neg_y_u(up_neg_yu) < peak_y_u(yu)
            up_neg = up_neg_yu;
        end
    end
    for down_neg_yu = 1:max(size(neg_y_u)) 
        if neg_y_u(down_neg_yu) > peak_y_u(yu)
            down_neg = down_neg_yu;
            break
        end
    end
    normal_peak_height_y = max_y_u(peak_y_u(yu)) - max(max_y_u(neg_y_u(up_neg)), max_y_u(neg_y_u(down_neg)));
    if normal_peak_height_y >= threshold & eye > 0 & eye_count > 0
        eye_y_u(yu) = normal_peak_height_y;
        % find  real peaks here
        diff_prev = 100; % set to something high to assure next diff is lower
        for xu = 1:2:max(size(eye_coordinates_x))
            xmax_curr = round(max(max_x_u_orig(eye_coordinates_x(xu):eye_coordinates_x(xu+1))) * 1000);
            ymax_curr = round(max(max_y_u_orig(neg_y_u(up_neg):neg_y_u(down_neg))) * 1000);
%             xmax
%             ymax
            diff_curr = abs(xmax_curr - ymax_curr);
            if xmax_curr == ymax_curr
                eye_count = (xu + 1)/2;
                break
            elseif diff_curr < diff_prev
                eye_count = (xu + 1)/2;
                diff_prev = diff_curr;
                
            else
                % eye_count = 0;
            end
        end
        if eye_count > 0
        for index = 2 * eye_count - 1:2 * eye_count
            if eye_count > eye
                % do nothing
            elseif eye_coordinates_y(index) == 0
                eye_coordinates_y(index) = neg_y_u(up_neg);
                eye_coordinates_y(index + 1) = neg_y_u(down_neg);
                % eye_count = eye_count + 1;
            end
        end
        end
    end
end

% eye_coordinates_x
% eye_coordinates_y

% fix any y eyes that were missed because the eyes were too close
% if eye > 0
%     for index = 2:2:eye * 2
%         if eye_coordinates_y(index) == 0
%            eye_coordinates_y(index) = 0; %set to low value, then reset to max 
%            eye_coordinates_y(index) = max(eye_coordinates_y);
%            %eye_coordinates_y(index + 1) = max(eye_coordinates_y);
%            if eye_coordinates_y(index) == length
%                eye_coordinates_y(index) = 0;
%            end
%         end
%     end
% end
% 
% if eye > 0
%     for index = 1:2:eye * 2
%         if eye_coordinates_y(index) == 0
%            % eye_coordinates_y(index) = min(eye_coordinates_y);
%            eye_coordinates_y(index) = min(eye_coordinates_y);
%            if eye_coordinates_y(index) == 0
%                eye_coordinates_y(index) = 5;
%            end
%         end
%     end
% end

if eye > 0
    for index = 1:1:eye * 2
        if eye_coordinates_y(index) == 0
            if index <= 2
                 eye_coordinates_y(index) = eye_coordinates_y(index + 2);
                 eye_coordinates_y(index + 1) = eye_coordinates_y(index + 3);
            else
                eye_coordinates_y(index) = eye_coordinates_y(index - 2);
                eye_coordinates_y(index + 1) = eye_coordinates_y(index - 1);
            end
        end
    end
end




figure;
imshow(norm_orig_image);
hold on
if eye > 0
%     for index = 1:max(size(eye_coordinates_x))
%         plot([eye_coordinates_x(index) eye_coordinates_x(index)], [width 1], 'r');
%     end
%     for index = 1:max(size(eye_coordinates_y))
%         plot([length 1], [eye_coordinates_y(index) eye_coordinates_y(index)], 'r');
%     end

    for index = 1:2:max(size(eye_coordinates_x) - 1)
        plot([eye_coordinates_x(index) eye_coordinates_x(index)], [eye_coordinates_y(index) eye_coordinates_y(index + 1)], 'g');
        plot([eye_coordinates_x(index + 1) eye_coordinates_x(index + 1)], [eye_coordinates_y(index) eye_coordinates_y(index + 1)], 'g');       
    end
    for index = 1:2:max(size(eye_coordinates_y) - 1)
        plot([eye_coordinates_x(index) eye_coordinates_x(index + 1)], [eye_coordinates_y(index) eye_coordinates_y(index)], 'g');
        plot([eye_coordinates_x(index) eye_coordinates_x(index + 1)], [eye_coordinates_y(index + 1) eye_coordinates_y(index + 1)], 'g');
        
    end
end
hold off
title('Detected Eye(s)');


