%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Gary Poon
% Ryan Wilshusen
%
% Red Eye Reduction Project
% This script verifies if red is present and if so, removes red eye
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all;
close all;

orig_image = imread('redeye.jpg'); % change the filename to change the image to be processed

eyedetect1

% imwrite(norm_orig_image, 'original_image.jpg', 'quality', 100);

% eye_coordinates_x
% eye_coordinates_y

if eye > 0
% create blank mask same size as original image
r_image = norm_orig_image(:, :, 1);
mask_image = r_image;
for index_x = 1:width
    for index_y = 1:length
        mask_image(index_x, index_y, 1) = 0;
    end
end

% bw_image = cat(3, y_image, mask_image, mask_image);
% bw_image = colorspace('rgb<-yuv', bw_image);
% 
% figure;
% imshow(bw_image);

bw_image = rgb2gray(norm_orig_image);
% figure;
% imshow(bw_image);


k = 0.01; %constant for redness
redness_threshold = 2.5; % experimental threashold value

for index = 1:2:max(size(eye_coordinates_x) - 1)
   for index_x = eye_coordinates_x(index):eye_coordinates_x(index + 1)
       for index_y = eye_coordinates_y(index):eye_coordinates_y(index + 1)
%            norm_orig_image(index_y, index_x, 1) = 0;
%              if norm_orig_image(index_y, index_x, 1) >= (2/3) & (norm_orig_image(index_y, index_x, 2) <= 0.4 || norm_orig_image(index_y, index_x, 3) <= 0.4)
%                   norm_orig_image(index_y, index_x, 1) = 0;
%                   mask_image(index_y, index_x) = 1;
%              end
            redness = ((norm_orig_image(index_y, index_x, 1))^2)/(((norm_orig_image(index_y, index_x, 2))^2) + ((norm_orig_image(index_y, index_x, 3))^2) + k);
            if redness > redness_threshold
                mask_image(index_y, index_x) = 1;
            end
       end
   end
end

radius = 2;
se = strel('disk', radius);
mask_image = imclose(mask_image, se);
% h = fspecial('gaussian', [5, 5], 10);
h = fspecial('disk', 1);
mask_image = imfilter(mask_image, h, 'circular', 'same');

% imwrite(mask_image, 'mask_image1.jpg', 'quality', 100);

figure;
imshow(mask_image);
title('Correction Factor Image');

ycbcr_image = rgb2ycbcr(norm_orig_image);

for index = 1:2:max(size(eye_coordinates_x) - 1)
   for index_x = eye_coordinates_x(index):eye_coordinates_x(index + 1)
       for index_y = eye_coordinates_y(index):eye_coordinates_y(index + 1)
           % ycbcr_image(index_y, index_x, 2:3) = 100 * ycbcr_image(index_y, index_x, 2:3);
           % ycbcr_image(index_y, index_x, 3) = 0 * ycbcr_image(index_y, index_x, 3); 
%            yuv_image(index_y, index_x, 2) = (1 - mask_image(index_y, index_x)) * yuv_image(index_y, index_x, 2);
%            yuv_image(index_y, index_x, 3) = (1 - mask_image(index_y, index_x)) * yuv_image(index_y, index_x, 3); 
            norm_orig_image(index_y, index_x, 1) = (1 - mask_image(index_y, index_x)) * norm_orig_image(index_y, index_x, 1) + (mask_image(index_y, index_x)) * bw_image(index_y, index_x);
            norm_orig_image(index_y, index_x, 2) = (1 - mask_image(index_y, index_x)) * norm_orig_image(index_y, index_x, 2) + (mask_image(index_y, index_x)) * bw_image(index_y, index_x);
            norm_orig_image(index_y, index_x, 3) = (1 - mask_image(index_y, index_x)) * norm_orig_image(index_y, index_x, 3) + (mask_image(index_y, index_x)) * bw_image(index_y, index_x);
       end
   end
end

end % end for if eye > 0

% corrected_image = ycbcr2rgb(ycbcr_image);
% corrected_image = colorspace('rgb<-yuv', yuv_image);

figure;
imshow(norm_orig_image);
title('Corrected Image');
% imwrite(norm_orig_image, 'corrected_image.jpg', 'quality', 100);